      PROGRAM CHECK

********************************************************************
*                                                                  *
*                     Author: A. BECK                              *
*                     2003-05-26                                   *
*                                                                  *
********************************************************************

      USE GRIB_API

      IMPLICIT NONE

      INTEGER I,J,K,L
      INTEGER INDE,LUNIT,LENGHT,LEV,LEVMIN,LEVMAX

 
      CHARACTER*1 YOPER
      integer ierr

      integer maxl, maxb, mlevel, levout, mnauf
      real rlo0, rlo1, rla0, rla1

      INTEGER MAUF, MANF,meta,metadiff
      
      integer npar,ipar,igrib
      parameter(npar=15)
      integer ireq(npar),isum(npar),iret,n
      integer MOMEGA,MOMEGADIFF,MGAUSS,METAPAR,MSMOOTH,MDPDETA

      character*4 ccheck(npar)
      integer icheck(npar),LLEN
      CHARACTER*300 MLEVELIST
      INTEGER,ALLOCATABLE ::  ILEVEL(:),MLINDEX(:)

  !HSO  grib api error messages
      integer :: gribVer,parCat,parNum,typSurf
      character(len=24) :: gribErrorMsg = 'Error reading grib file'
      character(len=20) :: gribFunction = 'gridcheck'

      data ccheck /"T","U","V","Q","LNSP","DETA","LSP","CP","SSHF",
     1     "SSR","EWSS","NSSS","OMEG","OMD","PTEN"/      
*      data ireq /130,131,132,133,134,77,142,143,146,176,180,181,
*     *135,001,158/         
      data isum /  1,  1,  1,  1, -1,  1, -1, -1, -1, -1, -1, -1,  1, 
     *1, -1/      
   

      NAMELIST /NAMGEN/
     1            MAXL, MAXB,
     2            MLEVEL,MLEVELIST,
     3            MNAUF,METAPAR,
     4            RLO0, RLO1, RLA0, RLA1,
     5            MOMEGA,MOMEGADIFF,MGAUSS,MSMOOTH,META,METADIFF,
     6            MDPDETA

      call posnam (4,'NAMGEN')
      read (4,NAMGEN)

      MAUF=INT(360.*(REAL(MAXL)-1.)/(RLO1-RLO0))

      MANF=INT(REAL(MAUF)/360.*(360.+RLO0)+1.)

      if(MDPDETA .ne. 1) THEN
        ireq =(/130,131,132,133,134,77,142,143,146,176,180,181,
     *135,001,158/)
      ELSE
        ireq =(/130,131,132,133,134,METAPAR ,142,143,146,176,180,181,
     *135,001,158/)
      ENDIF         

      allocate(ILEVEL(MLEVEL),MLINDEX(MLEVEL+1))

*******************************************************************
*     GRIB STUFF *
*******************************************************************


      icheck(:) = 0

*
* OPENING OF UNBLOCKED GRIB FILE
*
        call grib_open_file(LUNIT,'fort.15','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get_int(igrib,'editionNumber',gribVer,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          
          call grib_get(igrib,"parameterNumber",parNum,iret)
          call grib_get(igrib,"parameterCategory",parCat,iret)
          call grib_get(igrib,"paramId",ipar)
          call grib_get(igrib,"typeOfLevel",typSurf)
 
         if(gribVer .eq. 2 .and. ipar .eq. 3063 ) then ! acpcp [kg/m2] convert into m
            ipar=143
         endif
         if(gribVer .eq. 2 .and. ipar .eq. 0 ) then !  snow depth [kg/m2] convert into m
           if ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
              ipar=141         ! indicatorOfParameter   
           endif
         endif 
         
          do j=1,npar
            if(ireq(j) == ipar) icheck(j)=icheck(j)+isum(j)
          enddo
        enddo
        call grib_close_file(LUNIT)

*
* OPENING OF UNBLOCKED GRIB FILE
*
      IF(MOMEGADIFF .NE. 0 .OR. MOMEGA .NE. 0) THEN
        call grib_open_file(LUNIT,'fort.25','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get(igrib,"paramId",ipar)
 
          do j=1,npar
            if(ireq(j) == ipar) icheck(j)=icheck(j)+isum(j)
          enddo
        enddo
        call grib_close_file(LUNIT)
      ENDIF

 310  IERR = 0

*
* OPENING OF ETADOT FILE
*
      IF(METADIFF .NE. 0 .AND. META .NE. 0) THEN
        call grib_open_file(LUNIT,'fort.26','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get(igrib,"paramId",ipar)
 
          do j=1,npar
!            if(ireq(j) == ipar) icheck(j)=icheck(j)+1
          enddo
        enddo
        call grib_close_file(LUNIT)
      ENDIF

 410  IERR = 0

! parse levelist
      LLEN=len(trim(MLEVELIST))
      if(index(MLEVELIST,'to') .ne. 0 .or. index(MLEVELIST,'TO') .ne. 0) THEN
        i=index(MLEVELIST,'/')
        read(MLEVELIST(1:i-1),*) LEVMIN
        i=index(MLEVELIST,'/',.true.)
        read(MLEVELIST(i+1:LLEN),*) LEVMAX
        l=0
        do i=LEVMIN,LEVMAX
          l=l+1
          ILEVEL(l)=i
        enddo
      else
        l=1
	MLINDEX(1)=0
        do i=1,LLEN
          if(MLEVELIST(i:i) .eq. '/') THEN
	    l=l+1
	    MLINDEX(l)=i
	  endif
	enddo
	MLINDEX(l+1)=LLEN+1
	do i=1,l
	  read(MLEVELIST(MLINDEX(i)+1:MLINDEX(i+1)-1),*) ILEVEL(i)
	enddo
      endif 

      print*,npar,momegadiff,momega
      do i = 1, npar-2*(1-MOMEGADIFF)-(1-MOMEGA)
         if (icheck(i) .eq. -1) then
             write (*,9905) ccheck(i), abs(icheck(i))
         elseif (icheck(i) .ge. 1 .and.
     * icheck(i) .eq. l) then
            write (*,9900) ccheck(i), icheck(i), l
         else
            write (*,9910) ccheck(i), icheck(i), l
            IERR = IERR + 1
         endif
      enddo

      if (IERR .eq. 0) then
         open(12,file='CHECK.SUCCESS')
         write (12,*) 'CHECK FINISHED SUCCESSFULLY'
         close(12)
      else
         print*, 'CHECK FAILED !!!'
         STOP
      endif

 9900 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' expected: ',I3.2,' OK')

 9905 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' OK')

 9910 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' FAILED')

      END
      
